; A music player for the Turbo Grafx PSG
; by DamageX
; 3rd revision
;
;RAM map
;
;$2000   vblank (cleared at start of vb)
;
;$20AF   song bank
;$20B0-1 pointer for music
;$20B2   countdown until registers change
;
;$20BB-F vibrato (music player junk)
;
;$23EF-F1 old music bank, high, low
;
;$2540-9  frequencies (emulators don't like it when I read PSG regs)
;$254A-B  some junk
;
;$26C8-C  volume
;$26CD-D1 attack
;$26D2-D6 decay1
;$26D7-DB decay2
;$26DC-E0 T1L
;$26E1-E5 release
;$26E6-EA state
;$26EB-F  active volume high byte
;$26F0-4  active volume low byte
;$26F5-9  panning

	.bank 0
	.org $FFF6

	.dw null_int    ;IRQ2,  used by the BRK instruction
	.dw vb_int      ;IRQ1,  interrupt from the VDC
	.dw null_int    ;TIMER, not used in this demo
	.dw null_int    ;NMI,   never used (or may be by a HuCard!?)
	.dw reset_int   ;RESET, the most important one :)

	.org $E000


vb_int:
	pha
	phx
	phy
	lda $0000

; music player !        

	lda <$AF
	bne a322
	jmp a_323i
a322:
	tma #4
	pha
	lda <$AF
	tam #4
	cly
a315:                         ; big loop for emulating envelope
	tya
	tax
	lda $26E6,y
	bne a316
	lda $26E1,y           ; key off
	jsr subvol
	bra a317
a316:
	cmp #1                ; key on
	bne a_320i
	lda $26CD,y
	lsr a
	bcc a831
	pha
	lda $26F0,y
	adc #127
	sta $26F0,y
	pla
a831:
	adc $26EB,y
	sta $26EB,y
	cmp $26C8,y
	bcc a317
	lda $26C8,y
	sta $26EB,y
	inc $26E6,x
	bra a317
a_320i:
	cmp #2                ; decay 1
	bne a321

	lda $26D2,y
	jsr subvol

        stz $254A               ; how could this be forgotten for so long??
	cla
        phy
	ldy $26DC,x
	beq a836
a834:
	clc
	adc $26C8,x
	bcc a835
	inc $254A
a835:
	dey
	bne a834
	lsr $254A
	ror a
	lsr $254A
	ror a
	lsr a
	lsr a
	lsr a
a836:
        ply
	cmp $26EB,y
	bcc a317
	inc $26E6,x
	bra a317
a321:
	lda $26F0,y           ; decay 2
	sec
	sbc $26D7,y
	sta $26F0,y
	bcs a317
	dec $26EB,x
a317:
	iny
	cpy #5
        beq a833
        jmp a315
a833:

        clx
a_318i:
;        tya
;        tax
        lda $26EB,x
	bpl a319              ; check bounds
	stz $26EB,x           ;
a319:
        inx
        cpx #5
	bne a_318i

	cly
a306:
	sty $0800
	lda $26EB,y           ;
	ora #128              ; store volumes
	sta $0804             ;
	lda $26F5,y
	sta $0805
	iny
	cpy #5
	bne a306

	lda <$B2
	beq a307
	dec <$B2
	jmp a314
a307:
	lda [$B0]
	tax
	jsr incbzero
	cmp #255
	bne a326
	lda [$B0]
        pha
	jsr incbzero
	lda [$B0]
	tay
	jsr incbzero
	lda [$B0]
;        and #$1F
;        ora #$80
	sty <$B0              ;
	sta <$B1              ; a jump
        pla
        sta <$AF
	tam #4
	bra a307
a326:
	and #224
	bne a310
	lda [$B0]             ;
	sta $26C8,x           ; set a register
	jsr incbzero          ;
        bra a307
a310:
	cmp #32
	bne a312              ;
	txa                   ; wait frames
	and #31               ;
	sta <$B2
	bra a314
a312:
	cmp #128
	bne a313
	txa
	and #28               ;
	lsr a                 ; frequency change
	lsr a                 ;
	sta $0800
	tay
	txa
	and #3
	sta $0803
	sta $2545,y
	lda [$B0]
	sta $0802
	sta $2540,y
	jsr incbzero
	bra a307
a313:
	cmp #64
	bne a308
	txa
	and #62               ;
	lsr a                 ; key off/on
	tay                   ;
	txa
	and #1
	sta $26E6,y
	bra a307
a308:
	cmp #96
	bne a395
	txa                   ;
	and #16               ; vibrato on/off
	tay                   ;
	txa
	and #7
	tax
	sty <$BB,x
	bra a307
a395:
	cmp #160
	bne a837
	txa
	and #7
	tax
	lda [$B0]
        jsr incbzero
	ldy $26FA
	beq a838
	lda #255
	sta $26F5,x
	jmp a307
a838:
	sta $26F5,x
a837:
	jmp a307
       
a314:

	clx
a396:
	lda <$BB,x
	beq a397
	inc a
	cmp #26
	bne a398
	lda #16
a398:
	sta <$BB,x
	ldy $2545,x
	bne a399
	ldy $2540,x
	cpy #140
	bcs a399
;        
;        bra a397
;        clc
	adc #10
a399:
	tay
	stx $0800
        lda (vibpat-16),y
        sta $254C
        cmp #255
        beq a880
        cla
a880:
        pha
        lda $2540,x
	clc
        adc $254C
	sta $0802
	sta $2540,x
        pla
        adc $2545,x
        sta $0803
        sta $2545,x
a397:
	inx
	cpx #5
	bne a396

	pla
	tam #4

a_323i:

	ply
	plx
	pla
	stz <$00
null_int:
	rti

reset_int:
	sei                   ; disable interrupts 
	csh                   ; select the 7.16 MHz clock
	cld                   ; clear the decimal flag 
	lda #$FF              ; page 0 is i/o
	tam #0
	lda #$F8              ; page 1 is ram
	tam #1
	lda #$02              ; page 2 is rom bank
	tam #2
	lda #$03              ; page 3 is rom bank
	tam #3
	lda #$04              ; page 4 is rom bank
	tam #4

	stz $C01              ; stop the timer
	stz $2000             ; clear all the RAM
	tii $2000,$2001,$1FFF
	ldx #$FF              ; initialize the stack
	txs

        jsr initvid             
        jsr initpsg           

        lda #0                ; the first and only song in here

        tay
        asl a
        tax
        lda songaddrs,x
        sta <$B0
        lda songaddrs+1,x
        sta <$B1
        lda songbanks,y
        tax

	jsr initmus

        cli

sit:    jmp sit

subvol:
	stz $254B
	asl a
	rol $254B
	asl a
;        rol $254B
;        asl a
;        rol $254B
;        asl a
	rol $254B
	sta $254A
	lda $26F0,y
	sec
	sbc $254A
	sta $26F0,y
	lda $26EB,y
	sbc $254B
	sta $26EB,y
	rts

incbzero:
	inc <$B0
	bne a390
	pha
	inc <$B1
	lda <$B1
	cmp #$A0
        bne a881
	lda #$80
	sta <$B1
	inc <$AF
	lda <$AF
	tam #4
a881:
	pla
a390:
	rts

initmus:        
	stz <$AF
	stz <$BB
	stz <$BC
	stz <$BD
	stz <$BE
	stz <$BF
	stz $26C8
	tii $26C8,$26C9,$002C
	lda #238
	sta $26F5
	tii $26F5,$26F6,$0004

	lda $26FA
	bne a386

	lda #47
	sta $26F6
	sta $26F8
	lda #244
	sta $26F7
	sta $26F9
a386:
	tma #4
	pha
	
	cly
a324:
	txa
	tam #4
	lda [$B0]
	jsr incbzero
	phy
	phx
	pha
	lda #9
	tam #4
	pla
	jsr setwave
	plx
	ply
	iny
	cpy #5
	bne a324
	
	pla
	tam #4
	stx <$AF
	rts

initpsg:
	clx
a170:
	stx $0800
	stz $0804
	inx
	cpx #6
	bne a170
	ldx #$FF
	stx $0801
	rts

setwave:
	asl a
	asl a
	asl a
	asl a
	asl a
	sty $0800
	ldy #64
	sty $0804
	cly
	sty $0804
	tay
	ldx #32
a171:
	lda instruments,y
	sta $0806
	iny
	dex
	bne a171
	rts

initvid:
	st0 #5
	st1 #200              ; control reg
	st2 #0

	st0 #7
	st1 #0                ; scroll x
	st2 #0
	st0 #8
	st1 #0                ; scroll y
	st2 #0

	st0 #9
	st1 #144              ; screen size
	st2 #0

	st0 #10
	st1 #3                ; horizontal register things
	st2 #3

	st0 #11
	st1 #43               ; more h reg things
	st2 #6

	st0 #12
	st1 #2
	st2 #23
	st0 #13               ; vertical reg things
	st1 #223
	st2 #0
	st0 #14
	st1 #3
	st2 #0

	st0 #15
	st1 #16               ; dma reg
	st2 #0

	st0 #19
	st1 #0                ; sprite table adr
	st2 #$7F

	ldx #5
	stx $0400             ; color clock 
	rts

        .bank 1
        .org $C000

	.bank 2
	.org $4000

	.bank 3
	.org $6000

instruments:
	.db 30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,30,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
        .db 18,22,25,27,28,29,30,31,31,30,29,28,27,25,22,18,14,10,7,5,4,3,2,1,0,1,2,3,4,7,10,14
	.db 2,2,3,4,5,6,7,7,8,9,10,11,12,12,13,14,15,16,17,17,18,19,20,21,22,22,23,24,25,26,27,27
	.db 2,9,14,17,19,21,22,23,23,24,24,24,25,25,25,25,26,26,26,26,26,27,27,27,27,27,27,28,28,28,28,28

songbanks:
        .db BANK(musrov)
songaddrs:
	.dw musrov
vibpat:
	.db 1,1,0,255,255,255,255,0,1,1
	.db 0,1,0,0,255,0,255,0,0,1

musrov:

        .incbin "junk.dt"

; 255 is a 'jump' command, the bank-low-high address bytes follow

	.db 255
	.db BANK(musrov)
	.dw musrov+5

